<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              http://www.orionorigin.com
 * @since             1.0.0
 * @package           Otools
 *
 * @wordpress-plugin
 * Plugin Name:       ORION Tools
 * Plugin URI:        https://www.orionorigin.com
 * Description:       ORION Framework functions used by our themes.
 * Version:           1.3
 * Author:            ORION
 * Author URI:        http://www.orionorigin.com
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       otools
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}
define( 'ORION_URL', plugins_url('/', __FILE__) );
define( 'ORION_DIR', dirname(__FILE__) );
define ('ORION_THEME_SLUG', sanitize_title(wp_get_theme()));
define( 'OTOOLS_VERSION', '1.3' );
define( 'OTOOLS_URL', plugins_url('/', __FILE__) );
define( 'OTOOLS_DIR', dirname(__FILE__) );
define( 'OTOOLS_MAIN_FILE', 'otools/otools.php' );
/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-otools-activator.php
 */
function activate_otools() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-otools-activator.php';
	Otools_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-otools-deactivator.php
 */
function deactivate_otools() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-otools-deactivator.php';
	Otools_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_otools' );
register_deactivation_hook( __FILE__, 'deactivate_otools' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-otools.php';
if(!function_exists("orion_admin_fields"))
    require plugin_dir_path(__FILE__) . 'includes/utils.php';
//require plugin_dir_path(__FILE__) . 'includes/orion-importer/importer.php';
/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_otools() {

	$plugin = new Otools();
	$plugin->run();

}
run_otools();
