<?php 

    $queried_object=  get_queried_object();
    $taxonomies_args=array(
      "taxonomy" => 'category_portfolio'
    );
    
    if(isset($queried_object->term_id))
        $taxonomies_args["child_of"] = $queried_object->term_id;

    $tax_terms = get_terms( $taxonomies_args );
    
    global $porto_novo_options;
    $porto_novo_portfolio_layout = porto_novo_get_proper_value($porto_novo_options, 'opt-portfolio-blog-layout', '3');
    $thumbnail_size="porto-novo-portfolio-blog-$porto_novo_portfolio_layout";

    $all_filters = array();

    foreach ( $tax_terms as $tax_term ) {
    
        $all_filters[] = '.' . $tax_term->slug;

    }
    
    $all_filters_list = join( ", ", $all_filters );
    
    if(!empty($tax_terms))
    {
?>

<ul id="filters" class="clearfix">
    <li><span class="filter active" data-filter="<?php echo esc_attr($all_filters_list); ?>"><?php echo esc_html__('All', 'porto-novo'); ?></span></li>


     <?php 

        foreach ( $tax_terms as $tax_term ) {
        echo '<li><span class="filter" data-filter=".'. esc_attr($tax_term->slug).'">' . esc_attr($tax_term->slug ).'</span></li>';
        }
    ?>

</ul>
<?php
    }
$args = array(
    "post_type" => "o-portfolio", 
    "posts_per_page" => -1,
    );

    if(isset($queried_object->term_id))
        $args["tax_query"]=array(
                                array(
                                  'taxonomy' => 'category_portfolio',
                                  'field' => 'id',
                                  'terms' => $queried_object->term_id, // Where term_id of Term 1 is "1".
                                  'include_children' => true
                                ));

$query = new WP_Query($args);

if ($query->have_posts()) :

?><div id="portfolio-container" class="portfolio-container-<?php echo esc_attr($porto_novo_portfolio_layout) ?>c"><?php
    while ($query->have_posts()) : $query->the_post();
        $terms = get_the_terms( $post->ID, 'category_portfolio' );
                        
        if ( $terms && ! is_wp_error( $terms ) ) : 
         
            $filtering_links = array();
         
            foreach ( $terms as $term ) {
                $filtering_links[] = $term->slug;
            }
                                
            $filtering = join( " ", $filtering_links );
    
        endif;

        $image = get_the_post_thumbnail_url($post->ID, $thumbnail_size);
        $thumbnail_id=get_post_thumbnail_id($post->ID);
	$porto_novo_img_srcset = wp_get_attachment_image_srcset( $thumbnail_id, $thumbnail_size );
    ?>
         
    <div class="portfolio-item <?php echo esc_attr($filtering); ?>" data-cat="<?php echo esc_attr($filtering); ?>">

            <?php  ?>
            <a href="<?php echo esc_url(get_the_permalink($post->ID)); ?>" class="portfolio-link">
                <div class="caption">
                    <div class="caption-content">
                        <h3><?php echo get_the_title($post->ID); ?></h3>
                        <h4><?php echo esc_html( strip_tags(get_the_term_list($post->ID, "category_portfolio", "", "/", "")) ); ?></h4>
                    </div>
                </div>

                <?php the_post_thumbnail($thumbnail_size); ?>
                
            </a>

        </div>

    <?php

    endwhile;
    wp_reset_postdata();
else :
    ?>
    <p><?php esc_html_e('Sorry, no posts matched your criteria.', 'porto-novo'); ?></p>
<?php endif; ?>
</div>