<?php
/**
 * Template part for displaying a message that posts cannot be found.
 *
 * @link https://codex.wordpress.org/Template_Hierarchy
 *
 * @package Porto-Novo
 */

?>

<section class="error-404 not-found">

		<h1 class="page-title"><?php esc_html_e( 'Nothing Found', 'porto-novo' ); ?></h1>
	
	<div class="page-content">
		<?php
		if ( is_home() && current_user_can( 'publish_posts' ) ) : ?>

			<p><?php printf( 
                                /* translators: 1: link to create a new post */
                                wp_kses( esc_html__( 'Ready to publish your first post? <a href="%1$s">Get started here</a>.', 'porto-novo' ), array( 'a' => array( 'href' => array() ) ) ), esc_url( admin_url( 'post-new.php' ) ) ); ?></p>

		<?php elseif ( is_search() ) : ?>

			<p><?php esc_html_e( 'Sorry, but nothing matched your search terms. Please try again with some different keywords.', 'porto-novo' ); ?></p>
			<?php
				get_search_form();

		else : ?>

			<p><?php esc_html_e( 'It seems we can&rsquo;t find what you&rsquo;re looking for. Perhaps searching can help.', 'porto-novo' ); ?></p>
			<?php
				get_search_form();

		endif; ?>


	</div>

	<div class="social-network-container">
		<p class="title"><?php esc_html_e( 'Stay tuned', 'porto-novo' ); ?></p>

		<div class="social-network-links">
			<a href="#"><i class="fa fa-facebook"></i></a>
			<a href="#"><i class="fa fa-twitter"></i></a>
			<a href="#"><i class="fa fa-dribbble"></i></a>
			<a href="#"><i class="fa fa-instagram"></i></a>
			<a href="#"><i class="fa fa-pinterest"></i></a>
			<!-- <a href="#"><span class="ti-download"></span></a> -->
		</div>

	</div>
</section><!-- .no-results -->
<?php get_footer();