<?php
/**
 * Template part for displaying posts.
 *
 * @link https://codex.wordpress.org/Template_Hierarchy
 *
 * @package Porto-Novo
 */
?>

<?php
$template_class = porto_novo_get_category_template_class();
$unwanted_classes=array("content-area-no-sidebar", "content-area-plus-sidebar");
$template_class_for_size=str_replace($unwanted_classes, "", $template_class);
$thumbnail_size = sanitize_title($template_class_for_size);

if (is_single() && !is_home()) :
    ?>

    <article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
        <?php if ('' !== get_the_post_thumbnail()) : ?>
            <div class="post-thumbnail">
                <a href="<?php echo esc_url(get_the_permalink()); ?>">
                    <?php the_post_thumbnail('full'); ?>
                </a>
            </div>
        <?php endif; ?>



        <?php if ('post' === get_post_type()) : ?>

            <?php get_template_part('components/post/common-content', 'single'); ?>

        <?php endif; ?>

    </article><!-- #post-## -->

<?php endif; ?>

<?php if (is_archive() || is_front_page() || is_home()) : ?>

    
    <?php
    $post_class_arr=get_post_class();
    $post_class_str="";
    if(is_array( $post_class_arr )&&!empty($post_class_arr))
        $post_class_str=implode(" ",$post_class_arr);
    ?>
    <?php if (is_sticky($post->ID)) : ?>
    <article id="post-<?php the_ID(); ?>"  class="blog-archive-post sticky-post <?php echo esc_attr($post_class_str) ?> ">

        <?php else : ?>

        <article id="post-<?php the_ID(); ?>"  class="blog-archive-post <?php echo esc_attr($post_class_str) ?>">

            <?php endif; ?>
            <?php if ('' !== get_the_post_thumbnail()) : ?>
                <div class="post-thumbnail">
                    <a href="<?php echo esc_url(get_the_permalink()); ?>">
                        <span class="mask"></span>
                        <?php the_post_thumbnail($thumbnail_size); ?>	

                    </a>
                </div>
            <?php else: ?>
                <?php echo wp_kses_post(porto_novo_get_post_thumb()); ?>
            <?php endif; ?>
            <?php get_template_part('components/post/common-content', 'archive'); ?>

        </article>

    <?php endif; ?>
