<?php
/**
 * The template for displaying the footer.
 *
 * Contains the closing of the #content div and all content after.
 *
 * @link https://developer.wordpress.org/themes/basics/template-files/#template-partials
 *
 * @package Porto-Novo
 */
global $porto_novo_options;
$extra_class = "";
if(is_404() || porto_novo_is_coming_soon_active()) {
    $extra_class .= "transparent-footer";
}
?>

	</div>
	<footer id="colophon" class="site-footer <?php echo esc_attr($extra_class);?>">
	    <?php if(!is_404() && !porto_novo_is_coming_soon_active()) : ?>

	        <?php

	        global $porto_novo_options;

	        global $wp_registered_sidebars;

	        $top_footer_active = porto_novo_get_proper_value($porto_novo_options, 'opt-enable-top-footer', 1);
	        $top_footer_columns = porto_novo_get_proper_value($porto_novo_options, 'opt-top-footer-columns', 3);
	        $top_footer_layout = porto_novo_get_proper_value($porto_novo_options, 'opt-top-footer-layout', 'boxed');
	        $top_footer_max_width = porto_novo_get_proper_value($porto_novo_options, 'opt-top-footer-max-width', '1170');
	        $css = "max-width:" . $top_footer_max_width . "px";
	        
	        if ($top_footer_active) {
	            
	            ?>
	            <div class="top-footer-wrap fcol-<?php echo esc_attr($top_footer_columns); ?>" style="<?php if( 'boxed' === $top_footer_layout ) echo esc_attr($css); ?>">

	              <div class="footer-widgets-wrap <?php if('full-width' === $top_footer_layout) echo 'full-width'; ?>">    	          
                        <?php

                        if (array_key_exists( 'top-footer-column', $wp_registered_sidebars ) && is_active_sidebar('top-footer-column')) {
                        ?>
                        <div id="footer-widget-1" class="footer-widget-container">
                            <?php
                            dynamic_sidebar('top-footer-column');
                            ?></div><?php
                        }
                        ?>

                        <?php
                        if (array_key_exists( 'top-footer-column-2', $wp_registered_sidebars ) && is_active_sidebar('top-footer-column-2')) {
                            ?> 
                            <div id="footer-widget-2" class="footer-widget-container">
                                <?php
                                dynamic_sidebar('top-footer-column-2');
                                ?></div><?php
                        }
                        ?>

                        <?php
                        if (array_key_exists( 'top-footer-column-3', $wp_registered_sidebars ) && is_active_sidebar('top-footer-column-3')) {
                            ?>
                            <div id="footer-widget-3" class="footer-widget-container">
                                <?php
                                dynamic_sidebar('top-footer-column-3');
                                ?></div><?php
                        }
                        ?>
                        <?php
                        if (array_key_exists( 'top-footer-column-4', $wp_registered_sidebars ) && is_active_sidebar('top-footer-column-4')) {
                            ?>
                            <div id="footer-widget-4" class="footer-widget-container">
                                <?php
                                dynamic_sidebar('top-footer-column-4');
                                ?></div><?php
                        }
                        ?>
                        <?php
                        if (array_key_exists( 'top-footer-column-5', $wp_registered_sidebars ) && is_active_sidebar('top-footer-column-5')) {
                            ?>
                            <div id="footer-widget-5" class="footer-widget-container">
                                <?php
                                dynamic_sidebar('top-footer-column-5');
                                ?></div><?php
                        }
                        ?>
                    </div>        	              
                </div>
	            <?php
	                }

	    if(porto_novo_get_proper_value($porto_novo_options, 'opt-social-enable', 0)) :            
	                ?>
	                    

		<div id="footer-social-links-container">
			<ul id="footer-social-links">
			    <?php 
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-twitter')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-twitter')).'">'. esc_html__( 'Twitter','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-behance')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-behance')).'">'. esc_html__( 'Behance','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-pinterest')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-pinterest')).'">'. esc_html__( 'Pinterest','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-facebook')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-facebook')).'">'. esc_html__( 'Facebook','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-dribbble')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-dribbble')).'">'. esc_html__( 'Dribbble','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-vimeo')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-vimeo')).'">'. esc_html__( 'Vimeo','porto-novo').'</a></li>':'';
			
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-tumblr')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-tumblr')).'">'. esc_html__( 'Tumblr','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-linkedIn')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-linkedIn')).'">'. esc_html__( 'LinkedIn','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-google-plus')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-google-plus')).'">'. esc_html__( 'Google+','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-flickr')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-flickr')).'">'. esc_html__( 'Flickr','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-youtube')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-youtube')).'">'. esc_html__( 'Youtube','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-foursquare')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-foursquare')).'">'. esc_html__( 'Foursquare','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-instagram')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-instagram')).'">'. esc_html__( 'Instagram','porto-novo').'</a></li>':'';
			    
			    echo (porto_novo_get_proper_value($porto_novo_options, 'opt-social-github')!=='')?'<li><a href="'.esc_url(porto_novo_get_proper_value($porto_novo_options, 'opt-social-github')).'">'. esc_html__( 'GitHub','porto-novo').'</a></li>':'';
			    ?>

			</ul>
		</div>
	    <?php endif; ?>
	    <?php endif; ?>
		<?php get_template_part( 'components/footer/site', 'info' ); ?>
	</footer>
</div>
<?php wp_footer(); ?>

</body>
</html>
