<?php
/**
 *
 * @package Porto-Novo
 */

/**
 * Set up the WordPress core custom header feature.
 *
 * @uses porto_novo_header_style()
 */
function porto_novo_custom_header_setup() {
	add_theme_support( 'custom-header', apply_filters( 'porto_novo_custom_header_args', array(
		'default-image'          => '',
		'default-text-color'     => '000000',
		'width'                  => 2000,
		'height'                 => 250,
		'flex-height'            => true,
		'wp-head-callback'       => 'porto_novo_header_style',
	) ) );
}
add_action( 'after_setup_theme', 'porto_novo_custom_header_setup' );

if ( ! function_exists( 'porto_novo_header_style' ) ) :
/**
 * Styles the header image and text displayed on the blog
 *
 * @see porto_novo_custom_header_setup().
 */
function porto_novo_header_style() {
	$header_text_color = get_header_textcolor();

	// If we get this far, we have custom styles. Let's do this.
	?>
	<style type="text/css">
	<?php
		// Has the text been hidden?
		if ( 'blank' === $header_text_color ) :
	?>
		.site-title,
		.site-description {
			position: absolute;
			clip: rect(1px, 1px, 1px, 1px);
		}
	<?php
		// If the user has set a custom color for the text use that.
		else :
	?>
		.site-title a,
		.site-description {
			color: #<?php echo esc_attr( $header_text_color ); ?>;
		}
	<?php endif; ?>
	</style>
	<?php
}
endif; // porto_novo_header_style