<?php
/**
 * Custom functions that act independently of the theme templates.
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package Porto-Novo
 */

/**
 * Adds custom classes to the array of body classes.
 *
 * @param array $classes Classes for the body element.
 * @return array
 */
function porto_novo_body_classes( $classes ) {
        global $porto_novo_options;
	// Adds a class of group-blog to blogs with more than 1 published author.
	if ( is_multi_author() ) {
		$classes[] = 'group-blog';
	}

	// Adds a class of hfeed to non-singular pages.
	if ( ! is_singular() ) {
		$classes[] = 'hfeed';
	}
        
        if(porto_novo_is_coming_soon_active())
        {
            $classes[] = 'coming-soon-active';
        }
        
        $custom_wpd_option='opt-wpd-special-customization-page';
        $custom_wpd_page_style = porto_novo_get_proper_value($porto_novo_options, $custom_wpd_option, 1);
        if($custom_wpd_page_style)
        {
            $classes[] = $custom_wpd_option;
        }

	return $classes;
}
add_filter( 'body_class', 'porto_novo_body_classes' );