<?php
/**
 * The main template file.
 *
 * This is the most generic template file in a WordPress theme
 * and one of the two required files for a theme (the other being style.css).
 * It is used to display a page when nothing more specific matches a query.
 * E.g., it puts together the home page when no home.php file exists.
 *
 * @link https://codex.wordpress.org/Template_Hierarchy
 *
 * @package Porto-Novo
 */
get_header();
?>
<?php if (have_posts()) : 
    
    get_template_part('components/header/content', 'header');
    
    $class= porto_novo_get_category_template_class();
    ?>

    <div id="primary" class="content-area content-area-no-sidebar <?php echo esc_attr($class); ?>">


	<?php get_sidebar(); ?>
        <main id="main" class="site-main" >

    	<div class="posts-grid posts-grid-no-sidebar">

		<?php
		/* Start the Loop */
		while (have_posts()) : the_post();

		    /*
		     * Include the Post-Format-specific template for the content.
		     * If you want to override this in a child theme, then include a file
		     * called content-___.php (where ___ is the Post Format name) and that will be used instead.
		     */
		    get_template_part('components/post/content', get_post_format());



		endwhile;
		?>

    	</div>

	    <?php
    	porto_novo_page_navi();
	    ?>



        </main>
    </div>

    <?php
else :

    get_template_part('components/post/content', 'none');

endif;
get_footer();
