<?php
/**
 * The template for displaying all pages.
 *
 * This is the template that displays all pages by default.
 * Please note that this is the WordPress construct of pages
 * and that other 'pages' on your WordPress site may use a
 * different template.
 *
 * @link https://codex.wordpress.org/Template_Hierarchy
 *
 * @package Porto-Novo
 */

get_header(); 

while ( have_posts() ) : the_post();
    $post_id=  get_the_ID();
    global $porto_novo_page_settings;
    $porto_novo_page_settings=  get_post_meta($post_id, "porto-novo-page", true);
    $sidebar_class=  porto_novo_get_proper_value($porto_novo_page_settings, "sidebar-position", "left-sidebar");
    $layout_class=  porto_novo_get_proper_value($porto_novo_page_settings, "layout", "boxed");
    $revo_slider=  porto_novo_get_proper_value($porto_novo_page_settings, "revo-slider", false);
    $default_slider = porto_novo_get_proper_value($porto_novo_page_settings, "default-slider", false);
?>

	<?php
            get_template_part( 'components/header/content', 'header' );
        ?>

	<?php 
        $page_class="content-area $layout_class-layout";
        $show_sidebar=true;
        
        if(
                (function_exists("is_cart") && (is_cart()||is_checkout() ))
                || "no-sidebar" === $sidebar_class)
        {
            $page_class.=" content-area-no-sidebar";
            $show_sidebar=false;
        }

        if($default_slider) {

            $slider_post_ids = porto_novo_get_home_slider_posts_id();

            global $porto_novo_options;
            $portonovo_slider_type = porto_novo_get_proper_value($porto_novo_options, 'opt-home-page-slider-type', "");
            $blog_slider_width = porto_novo_get_proper_value($porto_novo_options, 'opt-blog-slider-width', "");
            $posts_ids = array();
            $slide_cpt = 1;
                ?>

                <div id="home-slider-area" class="<?php echo esc_attr($portonovo_slider_type); ?> <?php if($blog_slider_width) echo 'boxed';?>">

                    <ul class="home-slider">

                    <?php

                    $custom_query = new WP_query( array('post__in' => $slider_post_ids) );

                    while( $custom_query->have_posts() ) {
                        $custom_query->the_post();

                    echo '<li style="background-image: url(' . wp_get_attachment_url(get_post_thumbnail_id(get_the_ID())) . ');">';

                    
                    if('home-basic-slider' === $portonovo_slider_type) {
                        echo '<div class="home-slider-caption porto-novo-clearfix">';
                    ?>
                    
                    <div>
                        <p class="slide-number"><?php echo esc_html($slide_cpt); ?></p>
                        <p class="slide-category">
                        <?php
                            the_category(', ', '', get_the_ID());
                        ?>
                        </p>
                    </div>

                    <div>
                        <p class="slide-title"><?php echo the_title(); ?></p>
                        <p class="read-more"><a href="<?php the_permalink(); ?>"><?php echo '#&nbsp;' . esc_html__('Read more', 'porto-novo'); ?></a></p>       
                    </div>

                    <?php 
                    $slide_cpt++;
                    echo '</div>';
                    }

                    if('home-blog-slider' === $portonovo_slider_type) {
                    ?>
                    <div class="blog-slider-caption-mask">
                    <div class="blog-slider-caption-wrap">
                        
                        
                        <div class="blog-slider-caption-container">
                            
                            <h2 class="blog-slider-post-title"><?php echo the_title(); ?></h2>

                            <div class="blog-slider-post-extra">

                                <?php echo esc_html__('By', 'porto-novo'); ?>

                                <div>
                                    
                                    <?php the_author(); ?>
                                    
                                    
                                 </div>
                                 &nbsp;/&nbsp;
                                 <div>
                                    <?php the_category(', ', '', get_the_ID()); ?>
                                    
                                </div>
                                &nbsp;/&nbsp;
                                <div>
                                        <a href="<?php echo esc_url(get_the_permalink()); ?>">
                                    <?php comments_number( esc_html__('No Comments', 'porto-novo'), '1&nbsp;' . esc_html__('Comment', 'porto-novo'), '%&nbsp;'. esc_html__('Comments', 'porto-novo') ); ?>
                                    </a>
                                </div>
                                    
                            </div>
                            
                            <p class="blog-slider-post-light-excerpt">
                                <?php echo wp_trim_words(get_post_field('post_content', get_the_ID()), 20, '...'); ?>
                            </p>
                            <p class="blog-slider-read-more"><a href="<?php the_permalink(); ?>"><?php echo esc_html__('Read more', 'porto-novo'); ?></a></p>
                        </div>
                        </div>

                    </div>
                    
                    <?php
                    }
                    

                    echo '</li>';
                    }
                    wp_reset_postdata();
                    ?>
                    
                    </ul>

                </div>
                <?php

        } else {
        
            if($revo_slider)
            {
                ?>
                <div id="revo-slider-area">
                    <?php echo do_shortcode('[rev_slider alias="'.$revo_slider.'"]');?>
                </div>
                <?php
            }
        }
        ?>

        
	
	<div id="primary" class="<?php echo esc_attr($page_class) . ' ' . esc_attr($sidebar_class);?>">
	
		<?php 
                if($show_sidebar)
                    get_sidebar(); 
                ?>

		<main id="main" class="site-main" >

			<div id="site-content-wrap">

			<?php


				get_template_part( 'components/page/content', 'page' );

				// If comments are open or we have at least one comment, load up the comment template.
				if ( comments_open() || get_comments_number() ) :
					comments_template();
				endif;

			
			?>
                        </div>
		</main>

		
	</div>
<?php
endwhile; // End of the loop.
get_footer();