<?php
/**
 * Product quantity inputs
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/global/quantity-input.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see     https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce/Templates
 * @version 4.0.0
 */

defined( 'ABSPATH' ) || exit;

if(is_cart()) {

if ( $max_value && $min_value === $max_value ) {
	?>
	<div class="quantity hidden">
		<input type="hidden" id="<?php echo esc_attr( $input_id ); ?>" class="qty" name="<?php echo esc_attr( $input_name ); ?>" value="<?php echo esc_attr( $min_value ); ?>" />
	</div>
	<?php
} else {
	/* translators: %s: Quantity. */
	$label = ! empty( $args['product_name'] ) ? sprintf( __( '%s quantity', 'porto-novo' ), wp_strip_all_tags( $args['product_name'] ) ) : __( 'Quantity', 'porto-novo' );
	?>
	<div class="quantity">
		<label class="screen-reader-text" for="<?php echo esc_attr( $input_id ); ?>"><?php echo esc_attr( $label ); ?></label>
		<input
			type="number"
			id="<?php echo esc_attr( $input_id ); ?>"
			class="<?php echo esc_attr( join( ' ', (array) $classes ) ); ?>"
			step="<?php echo esc_attr( $step ); ?>"
			min="<?php echo esc_attr( $min_value ); ?>"
			max="<?php echo esc_attr( 0 < $max_value ? $max_value : '' ); ?>"
			name="<?php echo esc_attr( $input_name ); ?>"
			value="<?php echo esc_attr( $input_value ); ?>"
			title="<?php echo esc_attr_x( 'Qty', 'Product quantity input tooltip', 'porto-novo' ); ?>"
			size="4"
			inputmode="<?php echo esc_attr( $inputmode ); ?>" />
	</div>
	<?php
}

} else {

	if ( $max_value && $min_value === $max_value ) {
		?>
		<div class="quantity hidden">
			<input type="hidden" id="<?php echo esc_attr( $input_id ); ?>" class="qty" name="<?php echo esc_attr( $input_name ); ?>" value="<?php echo esc_attr( $min_value ); ?>" />
		</div>
		<?php
	} else if(isset ($input_id)){
		/* translators: %s: Quantity. */
		$label = ! empty( $args['product_name'] ) ? sprintf( __( '%s quantity', 'porto-novo' ), wp_strip_all_tags( $args['product_name'] ) ) : __( 'Quantity', 'porto-novo' );
	?>
	<div class="quantity-container">
		<table class="quantity-wrap">
		<tr>
		    <td class="quantity-label"><?php esc_html_e( 'QTY', 'porto-novo' ); ?></td>
		    <td class="quantity-change-box">
			    <button class="quantity-minus"><i class="fa fa-minus"></i></button>
			    <span>
					<input
						type="number"
						id="<?php echo esc_attr( $input_id ); ?>"
						class="<?php echo esc_attr( join( ' ', (array) $classes ) ); ?> quantity-text"
						step="<?php echo esc_attr( $step ); ?>"
						min="<?php echo esc_attr( $min_value ); ?>"
						max="<?php echo esc_attr( 0 < $max_value ? $max_value : '' ); ?>"
						name="<?php echo esc_attr( $input_name ); ?>"
						value="<?php echo esc_attr( $input_value ); ?>"
						title="<?php echo esc_attr_x( 'Qty', 'Product quantity input tooltip', 'porto-novo' ); ?>"
						size="4"
						inputmode="<?php echo esc_attr( $inputmode ); ?>" /> 
				</span>
			    <button class="quantity-plus"><i class="fa fa-plus"></i></button>
		    </td>
		</tr>
		</table>
	</div>
		<?php
	}

}

