<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of class-uie-banner
 *
 * @author HL
 */
class UIE_Banner_Group {

    public $id;
    private $args;

    public function __construct($group_id) {
        if ($group_id) {
            $this->id = $group_id;
//            $this->args=  get_post_meta($banner_id, "o-banner", true);
//            $this->args=  $this->get_args($raw_args);
        }
    }

    /**
     * Register the banner custom post type
     */
    public function register_cpt_banner_group() {

        $labels = array(
            'name' => __('Banner Group', 'uie'),
            'singular_name' => __('Banner Group', 'uie'),
            'add_new' => __('New banner', 'uie'),
            'add_new_item' => __('New banner', 'uie'),
            'edit_item' => __('Edit banner', 'uie'),
            'new_item' => __('New banner', 'uie'),
            'view_item' => __('View banner', 'uie'),
            //        'search_items' => __('Search a group', 'uie'),
            'not_found' => __('No banner found', 'uie'),
            'not_found_in_trash' => __('No banner in the trash', 'uie'),
            'menu_name' => __('Banners Group', 'uie'),
        );

        $args = array(
            'labels' => $labels,
            'hierarchical' => false,
            'description' => 'Banners Group',
            'supports' => array('title'),
            'public' => false,
            'show_ui' => true,
            'show_in_menu' => false,
            'show_in_nav_menus' => false,
            'publicly_queryable' => false,
            'exclude_from_search' => true,
            'has_archive' => false,
            'query_var' => false,
            'can_export' => true,
//            'menu_icon' => 'dashicons-schedule',
        );

        register_post_type('o-banner-group', $args);
    }

    /**
     * Adds the metabox for the banner CPT
     */
    public function get_banner_group_metabox() {

        $screens = array('o-banner-group');

        foreach ($screens as $screen) {

            add_meta_box(
                    'o-banner-settings-box', __('Banner Group settings', 'uie'), array($this, 'get_banner_group_settings_page'), $screen
            );
        }
    }

    /**
     * Banner Group CPT metabox callback
     */
    public function get_banner_group_settings_page() {
        wp_enqueue_media();
        ?>
        <div class='block-form'>
            <?php
            global $uie_skins;

            $begin = array(
                'type' => 'sectionbegin',
                'id' => 'uie-banner-container'
            );


            $nb_cols_desktop = array(
                'title' => __('Computers', 'uie'),
                'name' => "o-banner-group[nb-cols-xl]",
                'type' => 'number',
                'label_class' => 'o-o-col xl-1-3',
            );

            $nb_cols_tablets = array(
                'title' => __('Tablets', 'uie'),
                'name' => "o-banner-group[nb-cols-md]",
                'type' => 'number',
                'label_class' => 'o-col xl-1-3',
            );

            $nb_cols_smartphones = array(
                'title' => __('Smartphones', 'uie'),
                'name' => "o-banner-group[nb-cols-sm]",
                'type' => 'number',
                'label_class' => 'o-col xl-1-3',
            );

            $nb_cols = array(
                'title' => __('NB Columns', 'uie'),
                'desc' => __('Number of columns accross devices', 'uie'),
                'row_class' => "show-if-text",
                'type' => 'groupedfields',
                'fields' => array($nb_cols_desktop, $nb_cols_tablets, $nb_cols_smartphones)
            );
            
            $spacing_cols = array(
                        "0" => "0",
                        "8" => "8",
                        "16" => "16",
                        "24" => "24",
                        "40" => "40",
                    );

            $spacing_desktop = array(
                'title' => __('Large screens', 'uie'),
                'name' => "o-banner-group[xl-spacing]",
                'type' => 'select',
                'options' => $spacing_cols,
                'default' => "8",
                'label_class' => 'o-col xl-1-3',
            );

            $spacing_tablets = array(
                'title' => __('Medium screens', 'uie'),
                'name' => "o-banner-group[md-spacing]",
                'type' => 'select',
                'options' => $spacing_cols,
                'default' => "8",
                'label_class' => 'o-col xl-1-3',
            );
            
            $spacing_smartphones = array(
                'title' => __('Small screens', 'uie'),
                'name' => "o-banner-group[sm-spacing]",
                'type' => 'select',
                'options' => $spacing_cols,
                'default' => "8",
                'label_class' => 'o-col xl-1-3',
            );


            $spacing = array(
                'title' => __('Spacing', 'uie'),
                'desc' => __('Space between grid items', 'uie'),
                'row_class' => "show-if-text",
                'type' => 'groupedfields',
                'fields' => array($spacing_desktop, $spacing_tablets, $spacing_smartphones)
            );


            $banner = array(
                'title' => __('Banner', 'wad'),
                'name' => 'banner',
                'type' => 'post-type',
                'args' => array("post_type" => "o-banner", "nopaging" => true),
            );

            $banners_repeatable_fields = array(
                'title' => __('Intervals rules', 'wad'),
                'desc' => __('If quantity ordered between Min and Max, then the discount specified will be applied. <br>Leave Min or Max empty for any value (joker).', 'wad'),
                'name' => 'o-banner-group[banners]',
                'type' => 'repeatable-fields',
                'id' => 'intervals_rules',
                'fields' => array($banner)
            );

            $end = array('type' => 'sectionend');

            $settings = array(
                $begin,
                $nb_cols,
                $spacing,
                $banners_repeatable_fields,
                $end
            );

            echo o_admin_fields($settings);
            ?>
        </div>
        <?php
        global $o_row_templates;
        ?>
        <script>
            var o_rows_tpl =<?php echo json_encode($o_row_templates); ?>;
        </script>
        <?php
    }

    /**
     * Saves the display data
     * @param type $post_id
     */
    public function save_banner_group($post_id) {
        //Optimize and merge the two meta
        $meta_key = "o-banner-group";
        if (isset($_POST[$meta_key])) {
            update_post_meta($post_id, $meta_key, $_POST[$meta_key]);
        }
    }

}
