<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of class-uie-banner
 *
 * @author HL
 */
class UIE_Banner {

    public $id;
    private $args;

    public function __construct($banner_id) {
        if ($banner_id)
        {
            $this->id = $banner_id;
//            $this->args=  get_post_meta($banner_id, "o-banner", true);
//            $this->args=  $this->get_args($raw_args);
        }
    }

    /**
     * Register the banner custom post type
     */
    public function register_cpt_banner() {

        $labels = array(
            'name' => __('Banner', 'uie'),
            'singular_name' => __('Banner', 'uie'),
            'add_new' => __('New banner', 'uie'),
            'add_new_item' => __('New banner', 'uie'),
            'edit_item' => __('Edit banner', 'uie'),
            'new_item' => __('New banner', 'uie'),
            'view_item' => __('View banner', 'uie'),
            //        'search_items' => __('Search a group', 'uie'),
            'not_found' => __('No banner found', 'uie'),
            'not_found_in_trash' => __('No banner in the trash', 'uie'),
            'menu_name' => __('Banners', 'uie'),
        );

        $args = array(
            'labels' => $labels,
            'hierarchical' => false,
            'description' => 'Banners',
            'supports' => array('title'),
            'public' => false,
            'show_ui' => true,
            'show_in_menu' => true,
            'show_in_nav_menus' => false,
            'publicly_queryable' => false,
            'exclude_from_search' => true,
            'has_archive' => false,
            'query_var' => false,
            'can_export' => true,
//            'menu_icon' => 'dashicons-schedule',
        );

        register_post_type('o-banner', $args);
    }

    /**
     * Adds the metabox for the banner CPT
     */
    public function get_banner_metabox() {

        $screens = array('o-banner');

        foreach ($screens as $screen) {

            add_meta_box(
                    'o-banner-settings-box', __('Banner settings', 'uie'), array($this, 'get_banner_settings_page'), $screen
            );
        }
    }

    /**
     * Banner CPT metabox callback
     */
    public function get_banner_settings_page() {
        wp_enqueue_media();
        $types=  uie_get_skins_selectors_types_count();
        
        ?>
        <script>
            var uie_types_count='<?php echo json_encode($types);?>';
        </script>
                <div class='block-form'>
            <?php
            global $uie_skins;
            
            $begin = array(
                'type' => 'sectionbegin',
                'id' => 'uie-banner-container'
                    );

            $skins_options=array();
            foreach ($uie_skins as $skin_class=>$skin_data)
            {
                $skins_options[$skin_class]=$skin_data["name"];
            }
            
            $style = array(
                'title' => __('Style', 'uie'),
                'name' => 'o-banner[style]',
                'id' => 'o-banner-style-selector',
                'type' => 'select',
                'desc' => __('Please select your banner style.', 'uie'),
                'options' => $skins_options
            );
            
            $settings=array(
                $begin,
                $style,
                );
            $known_types=array("image"=>1, "text"=>5, "background"=>2);
            foreach ($known_types as $type=>$count)
            {
                    for($i=1; $i<=$count; $i++)
                    {
                        $data=call_user_func("uie_get_".$type."_properties", $i);
                        array_push($settings, $data);
                    }
            }
            
            $end = array('type' => 'sectionend');
            array_push($settings, $end);
            echo o_admin_fields($settings);
                    ?>
                </div>
            <?php
        global $o_row_templates;
            ?>
        <script>
            var o_rows_tpl=<?php echo json_encode($o_row_templates);?>;
        </script>
        <?php
    }
    
    /**
    * Saves the display data
    * @param type $post_id
    */
   public function save_banner($post_id) {
       //Optimize and merge the two meta
       $meta_key="o-banner";
       if(isset($_POST[$meta_key]))
       {
           update_post_meta($post_id, $meta_key, $_POST[$meta_key]);
       }
   }

}