<?php

function uie_get_text_properties($index) {
    $text = array(
        'title' => __('Text', 'uie'),
        'name' => "o-banner[$index][text]",
        'type' => 'textarea',
        'label_class' => 'o-col xl-1-1',
    );
    $url = array(
        'title' => __('Text URL', 'uie'),
        'name' => "o-banner[$index][url]",
        'type' => 'text',
        'label_class' => 'o-col xl-1-1',
    );
    $font_family = array(
        'title' => __('Font family', 'uie'),
        'name' => "o-banner[$index][font-family]",
        'type' => 'google-font',
        'label_class' => 'o-col xl-1-3',
    );
    $font_weight = array(
        'title' => __('Font weight', 'uie'),
        'name' => "o-banner[$index][font-weight]",
        'type' => 'select',
        'options' => array(
            "normal"=>__("Normal", "uie"),
            "300"=>"300",
            "400"=>"400",
            "700"=>"700",
            "900"=>"900",
            ),
        'label_class' => 'o-col xl-1-3',
    );
    $font_style = array(
        'title' => __('Font style', 'uie'),
        'name' => "o-banner[$index][font-style]",
        'type' => 'select',
        'options' => array(
            "normal"=>__("Normal", "uie"),
            "italic"=>__("Italic", "uie"),
            "oblique"=>__("Oblique", "uie"),
            "inherit"=>__("Initial", "uie"),
            "inherit"=>__("Inherit", "uie"),
            ),
        'label_class' => 'o-col xl-1-3',
    );
    $font_size = array(
        'title' => __('Font size', 'uie'),
        'name' => "o-banner[$index][font-size]",
        'type' => 'number',
        'label_class' => 'o-col xl-1-3',
    );
    $font_size_smartphone = array(
        'title' => __('Font size on smartphones', 'uie'),
        'name' => "o-banner[$index][font-size-smartphone]",
        'type' => 'number',
        'label_class' => 'o-col xl-1-3',
    );
    $font_size_tablet = array(
        'title' => __('Font size on tablets', 'uie'),
        'name' => "o-banner[$index][font-size-tablet]",
        'type' => 'number',
        'label_class' => 'o-col xl-1-3',
    );
    $border_width = array(
        'title' => __('Border Width', 'uie'),
        'name' => "o-banner[$index][border-width]",
        'type' => 'number',
        'label_class' => 'o-col xl-1-3',
    );
    $border_style = array(
        'title' => __('Border Style', 'uie'),
        'name' => "o-banner[$index][border-style]",
        'type' => 'select',
        'options' => array(
            "solid"=>__("Solid", "uie"),
            "dashed"=>__("Dashed", "uie"),
            "dotted"=>__("Dotted", "uie"),
            "double"=>__("Double", "uie"),
            "hidden"=>__("Hidden", "uie"),
            "inherit"=>__("Inherit", "uie"),
            "initial"=>__("Initial", "uie"),
            "inset"=>__("Inset", "uie"),
            "none"=>__("None", "uie"),
            "outset"=>__("Outset", "uie"),
            "ridge"=>__("Ridge", "uie"),
            
            ),
        'label_class' => 'o-col xl-1-3',
    );
    $border_color = array(
        'title' => __('Border Color', 'uie'),
        'name' => "o-banner[$index][border-color]",
        'type' => 'color',
        'label_class' => 'o-col xl-1-3',
    );
    $color = array(
        'title' => __('Color', 'uie'),
        'name' => "o-banner[$index][color]",
        'type' => 'color',
        'label_class' => 'o-col xl-1-2',
    );
    $color_hover = array(
        'title' => __('Color on hover', 'uie'),
        'name' => "o-banner[$index][color-hover]",
        'type' => 'color',
        'label_class' => 'o-col xl-1-2',
    );

    $element = array(
        'title' => __('Text', 'uie') . " $index",
        'desc' => __('Properties', 'uie'),
        'row_class' => "show-if-text",
        'type' => 'groupedfields',
        'fields' => array($text, $url, $font_family, $font_style, $font_weight, $color, $color_hover, $font_size, $font_size_tablet, $border_width, $border_style, $border_color, $font_size_smartphone)
    );

    return $element;
}

function uie_get_image_properties($index) {
    $image = array(
        'title' => __('Normal', 'uie'),
        'name' => "o-banner[$index][image]",
        'type' => 'image',
    );
    
    $image_hover = array(
        'title' => __('On hover', 'uie'),
        'name' => "o-banner[$index][image-hover]",
        'type' => 'image',
    );
    
    $element = array(
        'title' => __('Image', 'uie') . " $index",
        'desc' => __('Properties', 'uie'),
        'row_class' => "show-if-image",
        'type' => 'groupedfields',
        'fields' => array($image, $image_hover)
    );
    return $element;
}

function uie_get_background_properties($index) {
    $bg = array(
        'title' => __('Normal', 'uie'),
        'name' => "o-banner[$index][bg]",
        'type' => 'color',
        'label_class' => 'o-col xl-1-2',
    );
    $bg_hover = array(
        'title' => __('On Hover', 'uie'),
        'name' => "o-banner[$index][bg-hover]",
        'type' => 'color',
        'label_class' => 'o-col xl-1-2',
    );

    $element = array(
        'title' => __('Background', 'uie') . " $index",
        'desc' => __('Properties', 'uie'),
        'row_class' => "show-if-background",
        'type' => 'groupedfields',
        'fields' => array($bg, $bg_hover)
    );

    return $element;
}

function uie_get_available_skins() {

    $folders = scandir(UIE_SKINS_DIR);
    $skins_arr_from_files = array();
    foreach ($folders as $folder) {
        if ($folder == "." || $folder == "..")
            continue;
        $pattern = UIE_SKINS_DIR . "/$folder/class-uie-*-skin.php";
        foreach (glob($pattern) as $skin_file) {
            require_once $skin_file;
            $classes = uie_get_php_classes_from_file($skin_file);
            $skins_arr_from_files = array_merge($skins_arr_from_files, $classes);
        }
    }

    $skins_arr = apply_filters("uie_skins", $skins_arr_from_files);
    $output_arr = array();
    foreach ($skins_arr as $skin_class) {
        $skin_obj = new $skin_class(false);
        $properties = $skin_obj->get_properties();
        $output_arr[$skin_class] = $properties;
    }
    return $output_arr;
}

function uie_get_php_classes_from_file($filepath) {
    $php_code = file_get_contents($filepath);
    $classes = uie_get_php_classes_from_code($php_code);
    return $classes;
}

function uie_get_php_classes_from_code($php_code) {
    $classes = array();
    $tokens = token_get_all($php_code);
    $count = count($tokens);
    for ($i = 2; $i < $count; $i++) {
        if ($tokens[$i - 2][0] == T_CLASS && $tokens[$i - 1][0] == T_WHITESPACE && $tokens[$i][0] == T_STRING) {

            $class_name = $tokens[$i][1];
            $classes[] = $class_name;
        }
    }
    return $classes;
}

function uie_get_style($banner_id, $banner_properties, $skin_properties) {
    $handle = sanitize_title($skin_properties["name"]);
    $style_file_path = UIE_SKINS_DIR . "/" . $skin_properties["dir"] . "/style.css";
    $style_file_url = UIE_SKINS_URL . "/" . $skin_properties["dir"] . "/style.css";
    if (file_exists($style_file_path)) {
        wp_enqueue_style($handle, $style_file_url);
    }
    ob_start();
    echo "<style>";
    $text_index=1;
    $bg_index=1;
    foreach ($skin_properties["selectors"] as $i => $property) {
        $key=$i-1;
        if ($property["type"] == "text") {
            $font=$banner_properties[$text_index]["font-family"];
            echo "#uie-item-$banner_id ".$property["selector"] . "{";
            if($font)
            {
                $font_arr= explode("|", $font);
                $font_url=$font_arr[0];
                $font_name=$font_arr[1];
                $font_category=$font_arr[2];
                o_register_google_font($font_name, $font_url);
                echo "font-family: '$font_name', $font_category;";
            }
            
            if ($banner_properties[$text_index]["font-size"])
                echo "font-size: " . $banner_properties[$text_index]["font-size"] . "px;";
            if ($banner_properties[$text_index]["color"])
                echo "color: " . $banner_properties[$text_index]["color"] . ";";
            if ($banner_properties[$text_index]["font-weight"])
                echo "font-weight: " . $banner_properties[$text_index]["font-weight"] . ";";
            if ($banner_properties[$text_index]["font-size"])
                echo "font-style: " . $banner_properties[$text_index]["font-style"] . ";";
            if ($banner_properties[$text_index]["border-width"])
                echo "border-width: " . $banner_properties[$text_index]["border-width"] . "px;";
            if ($banner_properties[$text_index]["border-style"])
                echo "border-style: " . $banner_properties[$text_index]["border-style"] . ";";
            if ($banner_properties[$text_index]["border-color"])
                echo "border-color " . $banner_properties[$text_index]["border-color"] . ";";
            echo "}";

            //Hover
            if ($banner_properties[$text_index]["color"]) {
                echo "#uie-item-$banner_id ".$property["selector"] . ":hover{";
                echo "color: " . $banner_properties[$text_index]["color-hover"] . ";";
                echo "}";
            }

            //Smartphone
            if ($banner_properties[$text_index]["font-size-smartphone"]) {
                echo "@media only screen and (min-device-width : 320px) and (max-device-width : 480px) {";
                echo "#uie-item-$banner_id ".$property["selector"] . "{";
                echo "font-size: " . $banner_properties[$text_index]["font-size-smartphone"] . "px;";
                echo "}";
                echo "}";
            }

            //Tablet
            if ($banner_properties[$text_index]["font-size-tablet"]) {
                echo "@media only screen and (min-device-width : 481px) and (max-device-width : 768px) {";
                echo "#uie-item-$banner_id ".$property["selector"] . "{";
                echo "font-size: " . $banner_properties[$text_index]["font-size-tablet"] . "px;";
                echo "}";
                echo "}";
            }
            $text_index++;
        }
        else if ($property["type"] == "background") {
            echo "#uie-item-$banner_id ".$property["selector"] . "{";
            if ($banner_properties[$bg_index]["bg"])
                echo "background-color: " . $banner_properties[$bg_index]["bg"] . ";";
            echo "}";

            //Hover
            if ($banner_properties[$bg_index]["bg-hover"]) {
                echo "#uie-item-$banner_id ".$property["selector"] . ":hover{";
                echo "background-color: " . $banner_properties[$bg_index]["bg-hover"] . ";";
                echo "}";
            }
            $bg_index++;
        }
    }
    echo "</style>";
    $output = ob_get_clean();
    return $output;
}

function uie_get_banner_content($banner_id, $banner_properties, $skin_properties) {
    ob_start();
    
    $content_html=  str_replace("{banner-id}", $banner_id, $skin_properties["dynamic_content"]);
    $text_index=1;
    $img_index=1;
    
    foreach ($skin_properties["selectors"] as $i => $property) {
        if ($property["type"] == "text") {
            $content_html=  str_replace("{uie-text-$text_index}", $banner_properties[$text_index]["text"], $content_html);
            $content_html=  str_replace("{uie-url-$text_index}", $banner_properties[$text_index]["url"], $content_html);
            $text_index++;
        }
        else if ($property["type"] == "image") {
            $image_url=  o_get_proper_image_url($banner_properties[$img_index]["image"]);
            if($image_url)
            {
                $media_id=  uie_get_image_id_from_url($image_url);
                $image_html_code=wp_get_attachment_image( $media_id, "full");
                $content_html=  str_replace("{uie-image-$img_index}",$image_html_code, $content_html);
            }
                            
                //Hover image
            $image_hover_url=  o_get_proper_image_url($banner_properties[$img_index]["image-hover"]);
            if($image_hover_url)
            {
                $media_hover_id=  uie_get_image_id_from_url($image_hover_url);
                $image_hover_html_code=wp_get_attachment_image( $media_hover_id, "full");
                $content_html=  str_replace("{uie-image-hover-$img_index}",$image_hover_html_code, $content_html);
            }
            
            $img_index++;
        }
    }
    echo $content_html;
    $output = ob_get_clean();
    return $output;
}

function uie_get_image_id_from_url($image_url) {
	global $wpdb;
	$attachment = $wpdb->get_col($wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE guid like '%s';", "%$image_url%" )); 
        return $attachment[0]; 
}

function uie_get_skins_selectors_types_count() {
    global $uie_skins;

    $selectors_types = array();
    foreach ($uie_skins as $skin_class => $skin_data) {
        $selectors_types[$skin_class]=array();
        foreach ($skin_data["selectors"] as $selector) {
            $type=$selector["type"];
            if(isset($selectors_types[$skin_class][$type]))
                $selectors_types[$skin_class][$type]+=1;
            else
                $selectors_types[$skin_class][$type]=1;
        }
    }
    return $selectors_types;
}